unit MoDataMod;

interface

uses
  SysUtils, Classes, JvComponentBase, JvTrayIcon, Menus, StdActns, ActnList,
  ImgList, Controls;

type
  TMemomoDataModule = class(TDataModule)
    JvTrayIcon1: TJvTrayIcon;
    ActionList: TActionList;
    WordAddAction: TAction;
    WordPopupMenu: TPopupMenu;
    SysPopupMenu: TPopupMenu;
    FileAboutAction: TAction;
    MemomoA1: TMenuItem;
    Exit1: TMenuItem;
    FileExitAction: TAction;
    ImageList1: TImageList;
    WordNothingItemAction: TAction;
    procedure FileExitActionExecute(Sender: TObject);
    procedure DataModuleCreate(Sender: TObject);
    procedure WordAddActionExecute(Sender: TObject);
    procedure DataModuleDestroy(Sender: TObject);
    procedure FileAboutActionExecute(Sender: TObject);
  private
    { Private 錾 }
    FWordFileName: string;
    FWordList: TStringList;
    procedure RefreshWordMenu;
    procedure WordClick(Sender: TObject);
  public
    { Public 錾 }
  end;

var
  MemomoDataModule: TMemomoDataModule;

implementation

uses Forms, Dialogs, StrUtils, Clipbrd, MoAdd;

{$R *.dfm}

procedure TMemomoDataModule.FileExitActionExecute(Sender: TObject);
begin
	Application.Terminate;
end;

procedure TMemomoDataModule.WordClick(Sender: TObject);
var
	I: Integer;
begin
	I := (Sender as TMenuItem).Tag;
  Clipboard.AsText := FWordList[I];
end;

procedure TMemomoDataModule.RefreshWordMenu;
	function NewActItem(Action: TAction): TMenuItem;
	begin
  	Result := TMenuItem.Create(WordPopupMenu);
    Result.Action := Action;
  end;
  function NewSeparator: TMenuItem;
  begin
  	Result := TMenuItem.Create(WordPopupMenu);
    Result.Caption := '-';
  end;
var
	Item: TMenuItem;
  I: Integer;
begin
	with WordPopupMenu.Items do
  begin
  	Clear;
    Add(NewActItem(WordAddAction));
  	Add(NewSeparator);

    if FWordList.Count <= 0 then
    begin
    	Add(NewActItem(WordNothingItemAction));
      Exit;
    end;
    
    for I := 0 to FWordList.Count - 1 do
    begin
    	Item := TMenuItem.Create(WordPopupMenu);
      Item.Name := 'WORDITEM' + IntToStr(I);
      Item.Caption := FWordList[I];
      Item.Tag := I;
      Item.OnClick := WordClick;
      Add(Item);
    end;
  end;
end;

procedure TMemomoDataModule.DataModuleCreate(Sender: TObject);
begin
	FWordList := TStringList.Create;
  FWordList.Sorted := True;

	FWordFileName := ChangeFileExt(Application.ExeName, '.lst');
  try
  	FWordList.LoadFromFile(FWordFileName);
  except
  	on E: EFOpenError do
    	{ nothing };
  end;

  RefreshWordMenu;
end;

procedure TMemomoDataModule.WordAddActionExecute(Sender: TObject);
var
	Str: string;
begin
	if TMemomoWordAddForm.Execute(Str) then
  begin
  	if Trim(WideString(Str)) = '' then
    	Exit;

	  FWordList.Add(Str);
    RefreshWordMenu;
  end;
end;

procedure TMemomoDataModule.DataModuleDestroy(Sender: TObject);
begin
	if FWordList.Count > 0 then
  	FWordList.SaveToFile(FWordFileName);
end;

procedure TMemomoDataModule.FileAboutActionExecute(Sender: TObject);
const
	Msg = 'DelphiŖŃvO~OĂ݂邨'#13#10 +
				'http://pc8.2ch.net/test/read.cgi/tech/1158233434/';
begin
	MessageDlg(Msg, mtInformation, [mbOk], 0);
end;

end.

